// 这个接口页面，主要处理微信相关的接口
const _request= require('request');
const sha1 = require('sha1');
const _config = {
  "weixinsecret":{
    "wxd6109d07f6396e5c": "d80a330735fc82f3fd6aba425481e8fd",
    "wxe1849e28e176c67b": "90072420a6b6941b7b8af38afd019b9f"
  }
};
let share_json = {
  jsapi_ticket:'', //上一步获取的 ticket
  noncestr:'', //随机字符串
  timestamp: '' //事件戳
};

//获取token
function getsignature(req,res){
  let access_token_url = 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential';
  let jsapi_ticket_url = 'https://api.weixin.qq.com/cgi-bin/ticket/getticket?type=jsapi&access_token=';

  let get_access_token_url = access_token_url + '&appid=' + req.body.appId + '&secret=' + _config.weixinsecret[req.body.appId];

  new Promise((resolve, reject) => {
    return _request.get(get_access_token_url, function (error, response, body) {
      return error ? reject(error) : resolve(body);
    })

  }).then(function(newResult){
    let url = jsapi_ticket_url+JSON.parse(newResult).access_token;
    // 获取 ticket
    return  new Promise((resolve, reject) => {
      _request.get(url, function (err, rs, body) {
        share_json.jsapi_ticket = JSON.parse(body).ticket;
        share_json.noncestr = Math.random().toString(36).substr(2, 15); //随机字符串
        share_json.timestamp = parseInt(new Date().getTime() / 1000) + ''; //事件戳

        let str1 = 'jsapi_ticket='+share_json.jsapi_ticket + '&noncestr=' + share_json.noncestr +'&timestamp=' + share_json.timestamp + '&url=' + req.headers.referer;
        let token = sha1(str1);
        return err ? reject(err) : res.send({
          token: token, //上一步获取的 ticket
          noncestr: share_json.noncestr, //随机字符串
          timestamp: share_json.timestamp,
        });
      })
    })
  })
  .catch(function(e){
    console.log('有错误');
  });

}

// 获取token后分享
const wxGetsignature = function(req, res) {
    getsignature(req,res);
};

// 微信分享
const wxShare = function (req,res) {
  if(share_json.jsapi_ticket){
    let str1 = 'jsapi_ticket='+share_json.jsapi_ticket + '&noncestr=' + share_json.noncestr +'&timestamp=' + share_json.timestamp + '&url=' + req.headers.referer;
    let token = sha1(str1);
    return res.send({
      token: token, //上一步获取的 ticket
      noncestr: share_json.noncestr, //随机字符串
      timestamp: share_json.timestamp, //
    })
  }else{
    getsignature(req,res)
  }
};

module.exports = {
  wxGetsignature,
  wxShare
}
