const Router = require('express').Router
const router = Router()

const bodyParser = require('body-parser')
const multer = require('multer')
const upload = multer({ dest: 'upload_tmp/' })

const _test = require('../controller/TestMonitor')
const _wx = require('../controller/WxMonitor')

router.use(bodyParser.json({ limit: '60mb' }))
router.use(bodyParser.urlencoded({ extended: true, limit: '60mb' }))

router.post('/api/test', upload.any(), _test.isRun)

router.use('/api/*', upload.any(), (req, res) => { res.send('暂无该接口') })

// 重新获取token 在分享
router.post('/share/getsignature', function(req, res) {
    _wx.wxGetsignature(req,res)
});

// 微信分享
router.post('/share/token',function(req,res) {
    _wx.wxShare(req, res);
});

module.exports = router
